****** Master do file 

set more off
pause on
graph set window fontface "Times New Roman"
global mainpath "/Users/ekurt/Desktop/MP ASYM/Stata"
set seed 1073741823

*cap log close
*log using "${mainpath}/Log/Master_Log.log", replace

*************
**** DATA PREPARATION
*************
/*
do "${mainpath}/Do/1.Prepare dataset.do"
do "${mainpath}/Do/2.New variables and trims.do"
do "${mainpath}/Do/3.Annual data merge.do"
do "${mainpath}/Do/4.Estimation Prep.do"
*/

*************
**** MAIN FIGURE 1-3 ESTIMATION 
*************

do "${mainpath}/Do/52.LP prep_Baseline.do" 

*************
**** HETEROGENEITY TABLES (SINGLE CUT, TABLES. 1-6)
*************

*do "${mainpath}/Do/HETEROGENEITY/82.MP_Asym_IV_het_size.do" // Table 1
*do "${mainpath}/Do/HETEROGENEITY/82.MP_Asym_IV_het_dividend.do" // Table 2
*do "${mainpath}/Do/HETEROGENEITY/82.MP_Asym_IV_het_leverage.do" // Table 3
*do "${mainpath}/Do/HETEROGENEITY/82.MP_Asym_IV_het_liquidity.do" // Table 4
*do "${mainpath}/Do/HETEROGENEITY/82.MP_Asym_IV_het_credit_rating.do" // Table 5
*do "${mainpath}/Do/HETEROGENEITY/82.MP_Asym_IV_het_age.do" // Table 6


*************
**** DOUBLE CUT HETEROGENEITY TABLES (TABLES. C.7-C.11)
*************

*do "${mainpath}/Do/DOUBLE HETEROGENEITY/82.MP_Asym_IV_het_doublecut_DIV_SIZE.do" 
*do "${mainpath}/Do/DOUBLE HETEROGENEITY/82.MP_Asym_IV_het_doublecut_CREDIT RATING_SIZE.do" 
*do "${mainpath}/Do/DOUBLE HETEROGENEITY/82.MP_Asym_IV_het_doublecut_DIV_AGE.do" 
*do "${mainpath}/Do/DOUBLE HETEROGENEITY/82.MP_Asym_IV_het_doublecut_SIZE_AGE.do" 
*do "${mainpath}/Do/DOUBLE HETEROGENEITY/82.MP_Asym_IV_het_doublecut_DIV_CREDIT.do" 


*************
**** SUPPLEMENTARY FIGURES/TABLES
*************

/***********
**** Produces Table 7, Appendix Fig A1, Appendix Fig C8-C10.
**********
do "${mainpath}/Do/5.Descriptive Stats.do"
*/



cap log close
